<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of DotClear.
# Copyright (c) 2004 Olivier Meunier and contributors. All rights
# reserved.
#
# DotClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# DotClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#eze
# ***** END LICENSE BLOCK *****
#
# Contributor : Troopers (http://l.houdusse.free.fr/blog/)
#               ZeGuigui (http://www.zeguigui.com)
#

require_once dirname(__FILE__).'/module.php';

/*----------Definition des fonctions----------------------------*/
#affichage
function smDisplay()
{
	global $url,$images_path;
  
	buffer::str("<h2>".__('Smilies manager')."&nbsp;&nbsp;<a href=\"".$url."\">".
  	"<img src=\"".$images_path."back.png\" alt=\"".__('Back')."\" title=\"".__('Back')."\" /></a></h2>\r\n");
}

#affichage de tous les smilies du themes
function smDisplayAllSmilies($theme)
{ 
	global $url,$images_path;
  
  # Affiche un warning si la configuration n'autorise pas l'affichage des smileys !
  if (!dc_use_smilies) {
  	buffer::str("<h3>".__('Warning')."</h3>\r\n");
  	buffer::str("<strong>".__('Smileys disabled in dotclear configuration!')."</strong>\r\n");
  }

  buffer::str("<h3>".__('Configuration')."</h3>\r\n");
  
  # Liste des thmes
  $themes = new plugins(dirname(__FILE__).'/../../../themes/','theme');
  $themes->getPlugins(true);
  $themes_list = $themes->getPluginsList();
  	
  array_walk($themes_list,create_function('&$v','$v=$v["label"];'));
  $themes_list = array_flip($themes_list);
  
  buffer::str("<form action=\"".$url."\" method=\"post\">\r\n");
  buffer::str("<p><strong>".__('Manage theme smilies')."&nbsp;:&nbsp;</strong>".form::combo('p_theme',$themes_list,$theme)."\r\n");
  buffer::str("<input type=\"submit\" name=\"send\" id=\"send\" /></p>\r\n");
  buffer::str(dcNonce::form());
  buffer::str("</form>\r\n");
  
  buffer::str("<fieldset class=\"clear\">\r\n");
  
  #Liste des smilies
  $smilies = SmiliesManager::smSmiliesTab($theme);
  $i = 0;
  if (count($smilies)>0)
  {
    buffer::str("\t<table border=\"0\" cellpadding=\"0\" cellspacing=\"10\">\r\n");
    foreach($smilies as $key => $tab)
    {
    	$i = $i+1;
    	buffer::str("\t\t<tr>\r\n");
    	buffer::str("\t\t\t<td>".$tab[1]."</td>\r\n");
    	buffer::str("\t\t\t<td>".$key."</td>\r\n");
    	buffer::str("\t\t\t<td>".$tab[2]."</td>\r\n");
      buffer::str("\t\t\t<td><a href=\"".$url."&amp;action=edit&amp;num=".$i."&amp;theme=".$theme."\">".
  			"<img src=\"".$images_path."edit.png\" alt=\"".__('Edit')."\" title=\"".__('Edit')."\" /></a></td>\r\n");
      buffer::str("\t\t\t<td><a href=\"".$url."&amp;action=delete&amp;num=".$i."&amp;theme=".$theme."\" onclick=\"return window.confirm('".
  			addslashes(sprintf(__('Are you sure you want to delete this file: %s?'),$key))."');\">".
  			"<img src=\"".$images_path."delete.png\" alt=\"".__('Delete')."\" title=\"".__('Delete')."\" /></a></td>\r\n");
    	buffer::str("\t\t</tr>\r\n");
    }
    buffer::str("\t</table>\r\n");
  }
  else
  {
  	buffer::str("\t<p>".__("None smilies")."</p>\r\n");
  }
  buffer::str("</fieldset>\r\n");
  
  buffer::str("<form enctype=\"multipart/form-data\" action=\"".$url."\" method=\"post\">\r\n".
	"\t<fieldset class=\"clear\">\r\n".
  "\t\t<legend>".__('Add a smiley')."</legend>\r\n".
  "\t\t<label for=\"up_img\"><strong>".__('Upload a smiley')."&nbsp;: </strong>".
  "<br />".sprintf(__('Choose a file (max size %s)'),files::size(dc_upload_size))."</label>\r\n".
	"\t\t<input name=\"up_img\" id=\"up_img\" type=\"file\" />\r\n".
	"\t\t<input type=\"hidden\" name=\"p_theme\" value=\"".$theme."\" />\r\n".
  "\t\t<input type=\"hidden\" name=\"p_action\" value=\"add\" />\r\n".
  "\t\t<label for=\"emoticon\"><strong>".__('Emoticons')."&nbsp;: </strong>".
  "<br />".__('Enter smiley\'s emoticons separated by spaces')."</label>\r\n".
	"\t\t<input name=\"emoticon\" id=\"emoticon\" type=\"text\" value=\"\" /><br /><br />\r\n".
	"\t\t<input class=\"submit\" type=\"submit\" value=\"".__('send')."\" /></p>\r\n".
	dcNonce::form() . "\n" .
	"\t</fieldset>\r\n</form>\r\n");
  
  buffer::str("<h3>".__('Usage')."</h3>\r\n<fieldset class=\"clear\">\r\n".
	"<p><strong>".__('To see smilies and insert them in comments, in your form.php theme file add this function after the tag').htmlspecialchars(' </p> ').__('containing the comment textarea')." :</strong></p>\r\n");
	$str = "<?php SmiliesManager::smSmiliesToolbar('c_content'); ?>";
	buffer::str("<pre>".htmlspecialchars($str)."</pre>\r\n");
  buffer::str("<p><strong>".__('Caution!')." </strong>".__('If you had modified manually form.php to use Smilies Manager 0.1, you can not use the automatic modification and the automatic restore. Before, you must erase manually the modifications.')."</p>\r\n");
	buffer::str("<input type=\"button\" name=\"EditFile\" id=\"EditFile\" value=\"".__("Modify form.php")."\" onclick=\"window.location='".$url."&amp;action=editfile&amp;file=1';\" />\r\n");
  buffer::str("<input type=\"button\" name=\"RestoreFile\" id=\"RestoreFile\" value=\"".__("Restore form.php")."\" onclick=\"window.location='".$url."&amp;action=restorefile&amp;file=1';\" />\r\n");
  buffer::str("<p><strong>".__('To see smilies and insert them in posts, in the poster.php file in the directory ecrire add this line after the comments at the beginning')." :</strong></p>\r\n");
	$str = "require_once dirname(__FILE__).'/tools/smiliesmanager/functions.php';";
  buffer::str("<pre>".htmlspecialchars($str)."</pre>\r\n");
  buffer::str("<p><strong>".__('And add this function after the content text area (search for <tt>htmlspecialchars($content)</tt>)')." :</strong></p>\r\n");
	$str = "SmiliesManager::smSmiliesToolbar('p_content');";
	buffer::str("<pre>".htmlspecialchars($str)."</pre>\r\n");
  buffer::str("<input type=\"button\" name=\"EditFile\" id=\"EditFile\" value=\"".__("Modify poster.php")."\" onclick=\"window.location='".$url."&amp;action=editfile&amp;file=2';\" />\r\n");
  buffer::str("<input type=\"button\" name=\"RestoreFile\" id=\"RestoreFile\" value=\"".__("Restore poster.php")."\" onclick=\"window.location='".$url."&amp;action=restorefile&amp;file=2';\" />\r\n");
  buffer::str("<p><strong>".__('In the same way, to see smilies and insert them in a textarea, add this function after the tag').htmlspecialchars(' </p> ').__('containing the textarea')." :</strong></p>\r\n");
	$str = "SmiliesManager::smSmiliesToolbar('textareaname');";
	buffer::str("<pre>".htmlspecialchars($str)."</pre>\r\n");
  buffer::str("</fieldset>\r\n");
}

#affichage de l'edition
function smDisplayEdit($theme,$num)
{
	global $url;
  
	buffer::str("<h3>".__('Edition')."</h3>\r\n");
  
  $smilies = SmiliesManager::smSmiliesTab($theme);
  $keys = array_keys($smilies);
  
  buffer::str("<form enctype=\"multipart/form-data\" action=\"".$url."\" method=\"post\">\r\n".
	"\t<fieldset class=\"clear\">\r\n".
  "\t\t<p>".$smilies[$keys[$num-1]][1]."&nbsp;&nbsp;".$keys[$num-1]."<br /><br />\r\n".
  "\t\t<label for=\"up_img\"><strong>".__('Upload a smiley')."&nbsp;: </strong>".
  "<br />".sprintf(__('Choose a file (max size %s)'),files::size(dc_upload_size))."</label>\r\n".
	"\t\t<input name=\"up_img\" id=\"up_img\" type=\"file\" />\r\n".
	"\t\t<input type=\"hidden\" name=\"p_num\" value=\"".$num."\" />\r\n".
	"\t\t<input type=\"hidden\" name=\"p_theme\" value=\"".$theme."\" />\r\n".
  "\t\t<input type=\"hidden\" name=\"p_action\" value=\"save\" />\r\n".
  "\t\t<label for=\"emoticon\"><strong>".__('Emoticons')."&nbsp;: </strong>".
  "<br />".__('Enter smiley\'s emoticons separated by spaces')."</label>\r\n".
	"\t\t<input name=\"emoticon\" id=\"emoticon\" type=\"text\" value=\"".$smilies[$keys[$num-1]][2]."\" /><br /><br />\r\n".
	"\t\t<input class=\"submit\" type=\"submit\" value=\"".__('send')."\" /></p>\r\n".
	dcNonce::form() .
	"\t</fieldset>\r\n</form>");
}
/*--------------------------------------------------------------*/
/*----------Definition des variables----------------------------*/
$url = 'tools.php?p=smiliesmanager';
$images_path = 'tools/smiliesmanager/images/';

if (!empty($_POST))
{
	if (isset($_POST['p_theme']))
		$p_theme = trim($_POST['p_theme']);
  if (isset($_POST['p_action']))
    $p_action = trim($_POST['p_action']);
  if (isset($_POST['p_num']))
  	$p_num = trim($_POST['p_num']);
  if (isset($_POST['up_img']))
  	$up_img = trim($_POST['up_img']);
}
else
{
	if (!empty($_GET))
  {
  	if (isset($_GET['theme']))
    	$p_theme = trim($_GET['theme']);
    else
    	$p_theme = dc_theme;
  	if (isset($_GET['action']))
    	$p_action = trim($_GET['action']);
    if (isset($_GET['num']))
    	$p_num = trim($_GET['num']);
    if (isset($_GET['file']))
    	$p_file = trim($_GET['file']);
  }
  else
  {
		$p_theme = dc_theme;
  }
}
/*--------------------------------------------------------------*/
/*----------Actions---------------------------------------------*/
smDisplay();
switch ($p_action)
{
	case 'delete':
  	$smilies = SmiliesManager::smSmiliesTab($p_theme);
    if (SmiliesManager::smDeleteFile($p_theme,$smilies,$p_num) == TRUE)
    {
    	$new_smilies = array();
    	$keys = array_keys($smilies);
      foreach($smilies as $key => $tab)
      {
    		if (!($key == $keys[$p_num - 1]))
        	$new_smilies[$key] = $smilies[$key];
      }
      unset($smilies);
      $smilies = &$new_smilies;
    	if (SmiliesManager::smCreateFile($p_theme,$smilies) ==TRUE)
  			smDisplayAllSmilies($p_theme);
    }
    break;
  case 'edit':
  	smDisplayEdit($p_theme,$p_num);
  	break;
  case 'save':
    if (SmiliesManager::smUpload($p_theme) == TRUE)
    {
      $emoticon = '';
      $emoticons = explode(' ',$_POST['emoticon']);
    	foreach($emoticons as $key => $value)
      {
      	if (strcmp($value,'') != 0)
        	$emoticon = $emoticon.$value.'&nbsp;&nbsp;';
      }
      if (strcmp($emoticon,'') != 0)
      	$emoticon = substr($emoticon,0,strlen($emoticon)-strlen('&nbsp;&nbsp;'));
      $smilies = SmiliesManager::smSmiliesTab($p_theme);
      $new_smilies = array();
    	$keys = array_keys($smilies);
      foreach($smilies as $key => $tab)
      {
    		if (!($key == $keys[$p_num - 1]))
        	$new_smilies[$key] = $smilies[$key];
        else
        {
        	$tab[1] = '';
          $tab[2] = $emoticon;
        	$new_smilies[$_FILES['up_img']['name']] = $tab;
        } 
      }
      unset($smilies);
      $smilies = &$new_smilies;
      if (SmiliesManager::smCreateFile($p_theme,$smilies) ==TRUE)
    			smDisplayAllSmilies($p_theme);
    }
    break;
	case 'add':
  	if (SmiliesManager::smUpload($p_theme) == TRUE)
    {
    	$emoticon = '';
      $emoticons = explode(' ',$_POST['emoticon']);
    	foreach($emoticons as $key => $value)
      {
      	if (strcmp($value,'') != 0)
        	$emoticon = $emoticon.$value.'&nbsp;&nbsp;';
      }
      if (strcmp($emoticon,'') != 0)
      	$emoticon = substr($emoticon,0,strlen($emoticon)-strlen('&nbsp;&nbsp;'));
    	$smilies = SmiliesManager::smSmiliesTab($p_theme);
      $tab[1] = '';
      $tab[2] = $emoticon;
      $smilies[$_FILES['up_img']['name']] = $tab;
      if (SmiliesManager::smCreateFile($p_theme,$smilies) ==TRUE)
    			smDisplayAllSmilies($p_theme);
    }
    break;
  case 'editfile':
  	SmiliesManager::smEditFile($p_file);
    break;
  case 'restorefile':
  	SmiliesManager::smRestoreFile($p_file);
    break;
  default:
  	smDisplayAllSmilies($p_theme);
}
?>