<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of DotClear.
# Copyright (c) 2004 Olivier Meunier and contributors. All rights
# reserved.
#
# DotClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# DotClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#eze
# ***** END LICENSE BLOCK *****
#
# Contributor : Troopers (http://l.houdusse.free.fr/blog/)
#

class SmiliesManager
{
	#renvoie les smilies du thme sous forme de tableau
  function smSmiliesTab($theme)
  {
  	$smilies_path = (dc_app_url.'/themes/'.$theme.'/smilies/');
    $file_path = $_SERVER['DOCUMENT_ROOT'].$smilies_path.'smilies.txt';
  	$arr = array();
    
    if (dc_use_smilies && file_exists($file_path))
  	{
    	$def = file($file_path);
      foreach($def as $v)
  		{
      	$v = trim($v);
        if (preg_match('|^([^\t]*)[\t]+(.*)$|',$v,$matches))
        {
        	$file = $_SERVER['DOCUMENT_ROOT'].$smilies_path.$matches[2];
  	      
        	if (array_key_exists($matches[2], $arr))
          {
          	$arr[$matches[2]][2] = $arr[$matches[2]][2]."&nbsp;&nbsp;".$matches[1];
          }
          else
          {
          	if (file_exists($file))
  					{
          		$tab[1] = "<img src=\"".$smilies_path.$matches[2]."\" alt=\" ".$matches[1]."\" />";
            }
            else
            {
            	$tab[1] = "<br />";
            }   
            $tab[2] = $matches[1];
            $arr[$matches[2]] = $tab;
        	}
  			}
  		}
  	}
    return $arr;
  }

  #cre le fichier smilies.txt du thme en fonction d'un tableau de smilies
  function smCreateFile($theme,$arr)
  {
  	$smilies_path = $_SERVER['DOCUMENT_ROOT'].dc_app_url.'/themes/'.$theme.'/smilies/';
    $filename = 'smilies.txt';
    $file_path = $smilies_path.$filename;
    if (!is_dir($smilies_path))
    	mkdir($smilies_path,0700);
    if (file_exists($file_path) && !is_writable($file_path))
    {
  		buffer::str("<p>".sprintf(__('The file %s is not accessible in writing.'),$filename)."</p>\r\n");
      return FALSE;
  	}
  	if (!$handle = fopen($file_path, 'w')) 
    {
       buffer::str("<p>".sprintf(__('Impossible to open the file %s'),$filename)."</p>\r\n");
       return FALSE;
		}
		
    foreach($arr as $key => $tab)
		{
    	$string = explode("&nbsp;&nbsp;",$tab[2]);
      foreach($string as $i => $value)
      {
      	if (fwrite($handle, $value."\t\t".$key."\n") == FALSE) 
        {
        	buffer::str("<p>".sprintf(__('Impossible to write in the file %s'),$filename)."</p>\r\n");
          fclose($handle);
        	return FALSE;
        }
      }
    }  
   
  	fclose($handle);
    return TRUE;
  }

  #delete le fichier image du smiley
  function smDeleteFile($theme,$arr,$num)
  {
  	$smilies_path = (dc_app_url.'/themes/'.$theme.'/smilies/');
    $key = array_keys($arr);
    $filename = $key[$num-1];
    $file_path = $_SERVER['DOCUMENT_ROOT'].$smilies_path.$filename;
    
    if (file_exists($file_path))
    {
      if (unlink($file_path) == FALSE)
      {
      	buffer::str("<p>".sprintf(__('Impossible to delete the file %s'),$filename)."</p>\r\n");
        return FALSE;
    	}
    }
  	return TRUE;
  }
  
    #upload un fichier
  function smUpload($theme)
  {
  	if (!empty($_FILES['up_img']))
    {
    	$tmp_file = $_FILES['up_img']['tmp_name'];
  		$img_name = $_FILES['up_img']['name'];
      $up_dir = $_SERVER['DOCUMENT_ROOT'].$smilies_path.dc_app_url.'/themes/'.$theme.'/smilies/';
      
      if (!is_dir($up_dir))
      	mkdir($up_dir,0700);
        
    	if (version_compare(phpversion(),'4.2.0','>=')) 
      {
    		$upd_error = $_FILES['up_img']['error'];
    	} else {
    		$upd_error = 0;
    	}
      
      if($upd_error != 0)
    	{
    		switch ($upd_error) {
    			case 1:
    			case 2:
    				$err .= '<li>'.__('File size exceeds the authorized limit').'</li>';
    				break;
    			case 3:
    				$err .= '<li>'.__('File was only partially uploaded').'</li>';
    				break;
    			case 4:
    				$err .= '<li>'.__('No file').'</li>';
    				break; 
    		}
    	}
  		elseif(@move_uploaded_file($tmp_file,$up_dir.$img_name))
      {
      	$dest_img = $up_dir.$img_name;
    		
    		if(filesize($dest_img) > dc_upload_size)
    		{
    			$err .= '<li>'.__('File size exceeds the authorized limit').'</li>'; 
    		}
    		else
    		{	
    			if(($img_size = @getimagesize($dest_img)) == false)
    			{
    				$err .= '<li>'.sprintf(__('The file %s is not an image'),
    				'<strong>'.$img_name.'</strong>').'</li>';
    			}
    			else
    			{
    				$max_s = explode('x',dc_max_img_size);
    				$max_w = (int) $max_s[0];
    				$max_h = isset($max_s[1]) ? (int) $max_s[1] : 0;
    				
    				if ($max_w > 0 && $img_size[0] > $max_w)
    				{
    					$err .= '<li>'.__('Image is too large').'</li>';
    				}
    				elseif ($max_h > 0 && $img_size[1] > $max_h)
    				{
    					$err .= '<li>'.__('Image is too large').'</li>';
    				}
    			}
    		}
  
    		if ($err != '')
    		{
    			unlink($dest_img);
    		}
    		else
    		{
    			chmod($up_dir.$img_name,fileperms($up_dir) & ~0111);
    		}
  		}
    	else
    	{
    		$err .= '<li>'.__('An error occured while uploading the image').'</li>';
    	}
    }
    else
  	{
  		$err .= '<li>'.__('An error occured while uploading the image').'</li>';
  	}
    
    if ($err != '')
    {
    	buffer::str($err);
      return FALSE;
    }
    else
    {
    	return TRUE;
    }
  }
  
  #Edit les fichier form.php et poster.php 
  function smEditFile($num_file)
  {
  	if($num_file=='1')#form.php
    {
    	# Liste des thmes
      $themes = new plugins(dirname(__FILE__).'/../../../themes/','theme');
      $themes->getPlugins(true);
      $themes_list = $themes->getPluginsList();
      
      foreach($themes_list as $theme => $array)
      {
      	$file = $_SERVER['DOCUMENT_ROOT'].dc_app_url.'/themes/'.$theme.'/form.php';
        if(file_exists($file))
        {
        	if(!(file_exists($file.'.bak')))
          {
         		if(copy($file,$file.'.bak'))
            {
            	if (!$read_array = file($file)) 
              {
                 buffer::str("<p><strong>".sprintf(__("%s theme:"),$theme)." </strong>".__('Impossible to open the file form.php')."</p>\r\n");
                 return;
          		}
              if(!$handle = fopen($file, 'w'))
              {
                 buffer::str("<p><strong>".sprintf(__("%s theme:"),$theme)." </strong>".__('Impossible to write the file form.php')."</p>\r\n");
                 return;
          		}
              $in_comments=FALSE;
              $modified=FALSE;
              foreach($read_array as $key => $line)
              {
                if(strcmp(substr($line,0,27),"\t<textarea name=\"c_content\"")==0)
                	$in_comments=TRUE;
                if($in_comments && strcmp(substr($line,0,5),"\t</p>")==0)
                {
                	fwrite($handle,$line);
                	fwrite($handle,"\t<?php SmiliesManager::smSmiliesToolbar('c_content'); ?>\r\n");
                  $modified=TRUE;
                  $in_comments=FALSE;
                }
                else
	                fwrite($handle,$line);
              }
        			fclose($handle);
              if($modified)
    	          buffer::str("<p><strong>".sprintf(__("%s theme:"),$theme)." </strong>".__('The file form.php has been correctly modified')."</p>\r\n");
              else
              	buffer::str("<p><strong>".sprintf(__("%s theme:"),$theme)." </strong>".__('The file form.php has been corrupted')."</p>\r\n");
            }
            else
            	buffer::str("<p><strong>".sprintf(__("%s theme:"),$theme)." </strong>".__('Impossible to save the file form.php')."</p>\r\n");
          }
          else
          	buffer::str("<p><strong>".sprintf(__("%s theme:"),$theme)." </strong>".__('The backup of the file form.php already exists')."</p>\r\n");
        }
        else
          	buffer::str("<p><strong>".sprintf(__("%s theme:"),$theme)." </strong>".__('There is not file form.php')."</p>\r\n");
      }
    }
    else#poster.php
    {
    	$file = dirname(__FILE__) . '/../../poster.php';
      if(file_exists($file))
      {
      	if(!(file_exists($file.'.bak')))
        {
       		if(copy($file,$file.'.bak'))
          {
          	if (!$read_array = file($file)) 
            {
               buffer::str("<p>".__('Impossible to open the file poster.php')."</p>\r\n");
               return;
        		}
            if(!$handle = fopen($file, 'w'))
            {
               buffer::str("<p>".__('Impossible to write the file poster.php')."</p>\r\n");
               return;
        		}
            $in_comments=FALSE;
            $nb_modif=0;
            foreach($read_array as $key => $line)
            {
            	if(strcmp(substr($line,0,31),"# ***** END LICENSE BLOCK *****")==0)
              {
              	fwrite($handle,$line);
              	fwrite($handle,"require_once dirname(__FILE__).'/tools/smiliesmanager/functions.php';\r\n");
                $nb_modif++;
              }
              elseif(strcmp(substr($line,0,52),"\thtmlspecialchars(\$content),6,'class=\"max\"').'</p>';")==0)
              {
              	fwrite($handle,$line);
              	fwrite($handle,"\r\n\tSmiliesManager::smSmiliesToolbar('p_content');\r\n");
                $nb_modif++;
              }
              else
	              fwrite($handle,$line);
            }
      			fclose($handle);
            if($nb_modif==2)
  	          buffer::str("<p>".__('The file poster.php has been correctly modified')."</p>\r\n");
            else
            	buffer::str("<p>".__('The file poster.php has been corrupted')."</p>\r\n");
          }
          else
          	buffer::str("<p>".__('Impossible to save the file poster.php')."</p>\r\n");
        }
        else
        	buffer::str("<p>".__('The backup of the file poster.php already exists')."</p>\r\n");
      }
      else
        	buffer::str("<p>".__('There is not file poster.php')."</p>\r\n");
    }
  }
  
  #Restaure les fichier form.php et poster.php
  function smRestoreFile($num_file)
  {
  	if($num_file=='1')#form.php
    {
    	# Liste des thmes
      $themes = new plugins(dirname(__FILE__).'/../../../themes/','theme');
      $themes->getPlugins(true);
      $themes_list = $themes->getPluginsList();
      
      foreach($themes_list as $theme => $array)
      {
      	$file = $_SERVER['DOCUMENT_ROOT'].dc_app_url.'/themes/'.$theme.'/form.php';
        if(file_exists($file.'.bak'))
        {
       		if(copy($file.'.bak',$file))
          {
          	unlink($file.'.bak');
          	buffer::str("<p><strong>".sprintf(__("%s theme:"),$theme)." </strong>".__('The file form.php has been restored')."</p>\r\n");
          }
          else
          	buffer::str("<p><strong>".sprintf(__("%s theme:"),$theme)." </strong>".__('Impossible to restore the file form.php')."</p>\r\n");
        }
        else
          	buffer::str("<p><strong>".sprintf(__("%s theme:"),$theme)." </strong>".__('There is not backup of the file form.php')."</p>\r\n");
      }
    }
    else#poster.pho
    {
  		$file = dirname(__FILE__) . '/../../poster.php';
      if(file_exists($file.'.bak'))
      {
     		if(copy($file.'.bak',$file))
        {
        	unlink($file.'.bak');
        	buffer::str("<p>".__('The file poster.php has been restored')."</p>\r\n");
        }
        else
        	buffer::str("<p>".__('Impossible to restore the file poster.php')."</p>\r\n");
      }
      else
        	buffer::str("<p>".__('There is not backup of the file poster.php')."</p>\r\n");
    }   
  }
}
?>